""" CSeq C Sequentialization Framework
	source merging module

    written by Omar Inverso, University of Southampton.
"""
VERSION = 'merger-0.0-2015.10.20'
# VERSION = 'merger-0.0-2015.07.09'
#VERSION = 'merger-0.0-2014.12.24'  # CSeq-1.0beta
#VERSION = 'merger-0.0-2014.10.09'  # newseq-0.6a, newseq-0.6c SVCOMP15
#VERSION = 'merger-0.0-2014.09.27'
#VERSION = 'merger-0.0-2014.09.22'
#VERSION = 'merger-0.0-2014.02.25'
"""
Purpose of this module:

	- input sanitising (e.g. __thread_local workaround, removing non-standard C extensions, ...)
	- merge all the input files into one

	NOTE: the line mapping mechanism is very different from the other modules
	     (linemarkers are generated by the external preprocessor and thus follow
	      a different logic)

Prerequisites:
	gcc/cpp preprocessor prerequisites

Changelog:
	2015.10.20  patch for ldv-races category of SVCOMP16 (from 2_1 to 3_2)
	2015.07.12  new linemapping now mapping back from (outputline) -> (inputline,inputfile)
	2014.10.09  moved all parser-based code transformations from this module to  workarounds.py
	2014.10.09  modifying sanitise() to avoid using the preprocessor at that stage (easier line mapping)
	2014.09.27  new method sanitise() now includes all code-satinising, including thread_local workaround
	2014.09.22  moved thread local workaround from  new.py  to this module
	2014.09.22  load() / loadfromstring() now use gcc rather than cpp to preprocess,
	            needed to avoid problems with OSX (where cpp does not remove C++-style comments, causing parsing errors)
	2014.02.25  switched to  module.Module  base class for modules

"""


import pycparser.c_parser, pycparser.c_ast, pycparser.c_generator
import utils, common


class Info(pycparser.c_generator.CGenerator):
	infos = []        # input lines to output lines

	def __init__(self):
		pass	